:: -----------------------------------------------------------
:: Copyright (c) 2000-2022 Aras Corporation. All Rights Reserved.
:: -----------------------------------------------------------

echo off
set Server=%1
set Password=%2
if "%Server%" == "" (
      set Server=OAuthServer
)
if "%Password%" == "" (
      set Password=innovator
)
set Issuer=Aras Innovator
set OutDir=%~dp0\Output
set OpenSslDir=%~dp0

if not exist "%OpenSslDir%\openssl.exe" (
      echo Open the following link and download win32 or win64 OpenSSL version
      echo https://indy.fulgan.com/SSL/
      echo Extract archive to current directory.
      exit 1
)

if not exist "%OutDir%" (
      mkdir "%OutDir%"
)

set OPENSSL_CONF=%OpenSslDir%OpenSslConfig.cnf
:: Create private and public key
"%OpenSslDir%\openssl.exe" req -x509 -newkey rsa:2048 -days 825 -sha256 -keyout "%OutDir%\%Server%.key" -out "%OutDir%\%Server%.pem" -subj "/CN=%Issuer%" -passout pass:"%Password%" -extensions ext
:: Create public cer file
"%OpenSslDir%\openssl.exe" x509 -pubkey -outform der -in "%OutDir%\%Server%.pem" -out "%OutDir%\%Server%.cer"
:: Create pfx file
"%OpenSslDir%\openssl.exe" pkcs12 -export -out "%OutDir%\%Server%.pfx" -inkey "%OutDir%\%Server%.key" -in "%OutDir%\%Server%.pem" -passin pass:"%Password%" -passout pass:"%Password%"
del "%OutDir%\%Server%.key" "%OutDir%\%Server%.pem" 
